<h3>Outils</h3>
<div id="cleared"></div>

<h4>Administrations</h4>
<div class="card-group">
  <div class="card border-danger mb-3">
    <div class="card-header">
      <i class="fas fa-hammer"></i> Destruction des environnements
    </div>
    <div class="card-body">
      <p class="card-text">Arrêter toutes les environnements virtuels et purger les fichiers temporaires.</p>
    </div>
    <div class="card-footer">
       <button id="bt_destroy_vm" name="cleanall" class="btn btn-danger btn-block" type="button" onclick="destroy_all_vm()" disabled>Détruire</button>
    </div>
  </div>

  <div class="card border-primary mb-3">
    <div class="card-header">
       <i class="fas fa-random"></i> Maintenance applicative
    </div>
    <div class="card-body">
      <p class="card-text">Activer ou désactiver le mode maintenance</p>
    </div>
    <div class="card-footer">
      <div class="form-check form-check-inline">
      <input class="form-check-input" type="radio" name="maintenance" id="enable" value="1">
      <label class="form-check-label" for="enable">Activer</label>
      </div>
      <div class="form-check form-check-inline">
      <input class="form-check-input" type="radio" name="maintenance" id="disable" value="0">
      <label class="form-check-label" for="disable">Désactiver</label>
      </div>
    </div>
  </div>

</div>

<div id="cleared"></div>

<h4>Développement</h4>
<div class="card-group">

  <div class="card border-warning mb-3">
    <div class="card-header">
      <i class="fas fa-database"></i> Réinitialiser la base de données
    </div>
    <div class="card-body">
      <p class="card-text">Remettre à zéro les compteurs et supprimer l'historique des VM jetables.</p>
    </div>
    <div class="card-footer">
       <button id="bt_destroy_vm" name="reset_database" class="btn btn-warning btn-block" type="button" onclick="reset_database()">Réinitialiser</button>
    </div>
  </div>

  <div class="card border-info mb-3">
      <div class="card-header">
        <i class="fas fa-broom"></i> Vider le cache
      </div>
    <div class="card-body">
      <p class="card-text">Purger le cache de l'application web.</p>
    </div>
    <div class="card-footer">
      <button id="bt_flush_cache" name="flush_cache" class="btn btn-info btn-block" type="button" onclick="flush_cache()">Vider le cache</button>
    </div>
  </div>

</div>
<script>

    function destroy_all_vm() {
        if (confirm("Êtes-vous sûr ? Les VM seront détruites de façon irreversible !")) {
            block();
            $.ajax({
            url: '/api/cleanall',
            dataType: 'json',
            }).done(function (response) {
            unBlock();
            if (typeof response.success !== 'undefined') {
                if (response.success) {
                    messageBoxInfo("Destruction des environnements jetables : Opération executée");
                } else {
                  if (typeof response.maintenance !== 'undefined' && response.maintenance)
                    messageBoxWarning("Le système est en mode maintenance. Veuillez reessayer plus tard ...");
                else
                    messageBoxError("Error : "+response.message);
                }
            }
        });
        }
    };

    function reset_database() {
        if (confirm("Êtes-vous sûr ? Des données dans la BdD seront détruites de façon irreversible !")) {
            block();
            $.ajax({
            url: '/api/resetdatabase',
            dataType: 'json',
            }).done(function (response) {
            unBlock();
            if (typeof response.success !== 'undefined') {
                if (response.success) {
                    messageBoxInfo("Réinitialisation de la base de données : Opération executée");
                } else {
                    messageBoxError("Erreur lors de la réinitialisation de la BdD. Consultez les journaux d'évènements");
                }
            }
        });
        }
    };

    function flush_cache() {
            $.ajax({
            url: '/api/flushcache',
            dataType: 'json',
            }).done(function (response) {
            if (typeof response.success !== 'undefined') {
                if (response.success) {
                    messageBoxInfo("Nettoyage du cache : Opération executée");
                } else {
                    messageBoxError("Erreur lors du nettoyage du cache. Consultez les journaux d'évènements");
                }
            }
        });
    };

    function changeStateMaintenance(state) {
      $("#bt_destroy_vm").attr("disabled", ! state);
    };

    function checkStateMaintenance() {
      $.ajax({
      url: '/api/maintenance_state',
      dataType: 'json',
      }).done(function (response) {
          if (typeof response.success !== 'undefined') {
              if (response.success) {
                current_state=response.maintenance_admin || response.maintenance_tech;
                changeStateMaintenance(! current_state);
                value=response.maintenance_admin ? '1' : '0';
                $("input[name=maintenance][value='"+value+"']").prop('checked', true);
                if (current_state && (current_state !== last_check_maint))
                  messageBoxWarning("Le système est en mode maintenance");
                last_check_maint=current_state;
              }
          }
      });
    };

    $('input[name=maintenance]').change(function(){
      var value = $('input[name=maintenance]:checked').val();
      if (value=='1') {
        if (! confirm("Êtes-vous sûr de vouloir passer en mode maintenance ?")) {
          $("input[name=maintenance][value=0]").prop('checked', true);
          return;
        }
      }

      $.ajax({
      url: '/api/maintenance/'+value,
      dataType: 'json',
      }).done(function (response) {
          if (typeof response.success !== 'undefined') {
              if (response.success) {
                last_check_maint=response.maintenance_admin || response.maintenance_tech;
                changeStateMaintenance(! last_check_maint);
                messageBoxInfo("Opération executée");
              } else {
                messageBoxError("Impossible de changer l'état du mode maintenance");
              }
          }
      });
    });

    $(document).ready(function() {
      last_check_maint=undefined;
      setInterval(checkStateMaintenance, 60000);
      // First time
      checkStateMaintenance();
    });

</script>
